<template>
  <div>
    <div class="mt-8">
        <div class="mt-6">
        <div class="p-6 bg-white rounded-md shadow-md">

        <h2 class="text-lg text-gray-700 font-semibold capitalize">
              Pokemon List
        </h2>

          <table-filters v-on:setPagination="setPagination"
                         v-on:search="search"
          />
                <div class="-mx-4 sm:-mx-8 px-4 sm:px-8 py-4 overflow-x-auto">
                    <div class="inline-block min-w-full shadow rounded-lg overflow-hidden">
                        <table class="min-w-full leading-normal">
                            <thead>
                                <base-table-headers v-bind:headers="headers"
                                    >
                                </base-table-headers>
                            </thead>
                            <tbody>
                                <tr v-for="(row, index) in tableData"
                                    v-bind:item="row"
                                    v-bind:index="index"
                                    v-bind:key="row.id">

                                    <template v-for="(value, index) in row">
                                        <template v-if="index === 'Profile'">
                                            <record-button :key='index'
                                                            v-bind:value="value"
                                                >
                                            </record-button>
                                        </template>
                                        <template v-else-if="index === 'Sprite'">
                                            <base-table-image :key='index'
                                                            v-bind:value="value"
                                                >
                                            </base-table-image>
                                        </template>
                                        <template v-else>
                                            <base-table-cell :key='index'
                                                            v-bind:value="value"
                                                >
                                            </base-table-cell>
                                        </template>                                            
                                    </template>
                                </tr>
                            </tbody>
                        </table>
                        <div
                            class="px-5 py-5 bg-white border-t flex flex-col xs:flex-row items-center xs:justify-between">
                            <span class="text-xs xs:text-sm text-gray-900">Showing {{meta.from}} to {{meta.to}} of {{meta.total}} Entries</span>

                            <div class="inline-flex mt-2 xs:mt-0">
                                <button v-if="links.first !== null" v-on:click="fetchRecords(links.first)" class="text-sm bg-gray-300 hover:bg-gray-400 text-gray-800 font-semibold py-2 px-4 rounded-l">first</button>
                                <button v-if="links.prev !== null" v-on:click="fetchRecords(links.prev)" class="text-sm bg-gray-300 hover:bg-gray-400 text-gray-800 font-semibold py-2 px-4">Prev</button>
                                <button v-if="links.next !== null" v-on:click="fetchRecords(links.next)" class="text-sm bg-gray-300 hover:bg-gray-400 text-gray-800 font-semibold py-2 px-4">Next</button>
                                <button v-if="links.last !== null" v-on:click="fetchRecords(links.last)" class="text-sm bg-gray-300 hover:bg-gray-400 text-gray-800 font-semibold py-2 px-4 rounded-r">Last</button>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
    </div>
</template>
<script>
    import axios from 'axios'
    import TableFilters from './UI/TableFilters.vue'
    import BaseTableHeader from './UI/BaseTableHeader.vue'
    import BaseTableCell from './UI/BaseTableCell.vue'
    import RecordButton from './UI/RecordButton.vue'
    import BaseTableImage from './UI/BaseTableImage.vue'
    export default ({
        name: 'BaseTable',
        props: {
            title: String,
            apiEndpoint: String,
            pagination: Number,
            page: Number,
            reload: Boolean,
        },
        components: {
          'table-filters' : TableFilters,
          'base-table-headers' : BaseTableHeader,
          'base-table-cell' : BaseTableCell,
          'record-button' : RecordButton,
          'base-table-image': BaseTableImage
        },
        data: function() {
            return {
                tableData: [],
                headers: [],
                meta: {},
                links: {},
                currentPagination: ''
                }
        },
        created: function () {
            this.currentPagination = this.pagination;
            this.fetchRecords(this.apiEndpoint + '?page=' + this.page);
        },
        watch: { 
            reload: function(newVal, oldVal) {
                this.fetchRecords(this.apiEndpoint + '?page=' + this.page)
            }
        },
        methods: {
            fetchRecords: function (page_url) {
                var vm = this;
                axios
                    .get(page_url + '&perPage=' + this.currentPagination)
                    .then(function (response) {
                        vm.tableData = response.data.data;
                        vm.meta = response.data.meta;
                        vm.links = response.data.links; 
                        vm.headers = Object.keys(vm.tableData[0])
                    });
            },
            setPagination: function (pagination) {
                this.currentPagination = pagination;
                this.fetchRecords(this.apiEndpoint + '?page=' + this.page);
            },
            search: function (term) {
                this.fetchRecords(this.apiEndpoint + '?page=' + this.page + '&search=' + term);
            }
        },
    });
</script>